package icurl

import "github.com/c-bata/go-prompt"

func optionCompleter(d prompt.Document) []prompt.Suggest {
	s := []prompt.Suggest{
		{Text: "--abstract-unix-socket ", Description: "Connect via abstract Unix domain socket"},
		{Text: "--alt-svc", Description: "Enable alt-svc with this cache file"},
		{Text: "--anyauth", Description: "Pick any authentication method"},
		{Text: "--append", Description: "Append to target file when uploading"},
		{Text: "--basic", Description: "Use HTTP Basic Authentication"},
		{Text: "--cacert", Description: "CA certificate to verify peer against"},
		{Text: "--capath", Description: "CA directory to verify peer against"},
		{Text: "--cert", Description: "Client certificate file and password"},
		{Text: "--cert-status", Description: "Verify the status of the server certificate"},
		{Text: "--cert-type", Description: "Certificate file type (DER/PEM/ENG)"},
		{Text: "--ciphers", Description: "SSL ciphers to use"},
		{Text: "--compressed", Description: "Request compressed response,"},
		{Text: "--compressed-ssh", Description: "Enable SSH compression"},
		{Text: "--config", Description: "Read config from a file"},
		{Text: "--connect-timeout", Description: "Maximum time allowed for connection"},
		{Text: "--connect-to", Description: "Connect to host"},
		{Text: "--continue-at", Description: "Resumed transfer offset"},
		{Text: "--cookie", Description: "Send cookies from string/file"},
		{Text: "--cookie-jar", Description: "Write cookies to <filename> after operation"},
		{Text: "--create-dirs", Description: "Create necessary local directory hierarchy"},
		{Text: "--crlf", Description: "Convert LF to CRLF in upload"},
		{Text: "--crlfile", Description: "Get a CRL list in PEM format from the given file"},
		{Text: "--data", Description: "HTTP POST data"},
		{Text: "--data-ascii", Description: "HTTP POST ASCII data"},
		{Text: "--data-binary", Description: "HTTP POST binary data"},
		{Text: "--data-raw", Description: "HTTP POST data, '@' allowed"},
		{Text: "--data-urlencode", Description: "HTTP POST data url encoded"},
		{Text: "--delegation", Description: "GSS-API delegation permission"},
		{Text: "--digest", Description: "Use HTTP Digest Authentication"},
		{Text: "--disable", Description: "Disable .curlrc"},
		{Text: "--disable-eprt", Description: "Inhibit using EPRT or LPRT"},
		{Text: "--disable-epsv", Description: "Inhibit using EPSV"},
		{Text: "--disallow-username-in-url", Description: "Disallow username in url"},
		{Text: "--dns-interface", Description: "Interface to use for DNS requests"},
		{Text: "--dns-ipv4-addr", Description: "IPv4 address to use for DNS requests"},
		{Text: "--dns-ipv6-addr", Description: "IPv6 address to use for DNS requests"},
		{Text: "--dns-servers", Description: "DNS server addrs to use"},
		{Text: "--doh-url", Description: "Resolve host names over DOH"},
		{Text: "--dump-header", Description: "Write the received headers to <filename>"},
		{Text: "--egd-file", Description: "EGD socket path for random data"},
		{Text: "--engine", Description: "Crypto engine to use"},
		{Text: "--expect100-timeout", Description: "How long to wait for 100-continue"},
		{Text: "--fail", Description: "Fail silently (no output at all) on HTTP errors"},
		{Text: "--fail-early", Description: "Fail on first transfer error, do not continue"},
		{Text: "--false-start", Description: "Enable TLS False Start"},
		{Text: "--form", Description: "Specify multipart MIME data"},
		{Text: "--form-string", Description: "Specify multipart MIME data"},
		{Text: "--ftp-account", Description: "Account data string"},
		{Text: "--ftp-alternative-to-user", Description: "String to replace USER [name]"},
		{Text: "--ftp-create-dirs", Description: "Create the remote dirs if not present"},
		{Text: "--ftp-method", Description: "Control CWD usage"},
		{Text: "--ftp-pasv", Description: "Use PASV/EPSV instead of PORT"},
		{Text: "--ftp-port", Description: "Use PORT instead of PASV"},
		{Text: "--ftp-pret", Description: "Send PRET before PASV"},
		{Text: "--ftp-skip-pasv-ip", Description: "Skip the IP address for PASV"},
		{Text: "--ftp-ssl-ccc", Description: "Send CCC after authenticating"},
		{Text: "--ftp-ssl-ccc-mode", Description: "Set CCC mode"},
		{Text: "--ftp-ssl-control", Description: "Require SSL/TLS for FTP login, clear for transfer"},
		{Text: "--get", Description: "Put the post data in the URL and use GET"},
		{Text: "--globoff", Description: "Disable URL sequences and ranges using {} and []"},
		{Text: "--happy-eyeballs-timeout-ms", Description: "<milliseconds> How long to wait in milliseconds for IPv6 before trying IPv4"},
		{Text: "--haproxy-protocol", Description: "Send HAProxy PROXY protocol v1 header"},
		{Text: "--head", Description: "Show document info only"},
		{Text: "--header", Description: "Pass custom header(s) to server"},
		{Text: "--help", Description: "This help text"},
		{Text: "--hostpubmd5", Description: "Acceptable MD5 hash of the host public key"},
		{Text: "--http0.9", Description: "Allow HTTP 0.9 responses"},
		{Text: "--http1.0", Description: "Use HTTP 1.0"},
		{Text: "--http1.1", Description: "Use HTTP 1.1"},
		{Text: "--http2", Description: "Use HTTP 2"},
		{Text: "--http2-prior-knowledge", Description: "Use HTTP 2 without HTTP/1.1 Upgrade"},
		{Text: "--ignore-content-length", Description: "Ignore the size of the remote resource"},
		{Text: "--include", Description: "Include protocol response headers in the output"},
		{Text: "--insecure", Description: "Allow insecure server connections when using SSL"},
		{Text: "--interface", Description: "Use network INTERFACE (or address)"},
		{Text: "--ipv4", Description: "Resolve names to IPv4 addresses"},
		{Text: "--ipv6", Description: "Resolve names to IPv6 addresses"},
		{Text: "--junk-session-cookies", Description: "Ignore session cookies read from file"},
		{Text: "--keepalive-time", Description: "Interval time for keepalive probes"},
		{Text: "--key", Description: "Private key file name"},
		{Text: "--key-type", Description: "Private key file type (DER/PEM/ENG)"},
		{Text: "--krb", Description: "Enable Kerberos with security <level>"},
		{Text: "--libcurl", Description: "Dump libcurl equivalent code of this command line"},
		{Text: "--limit-rate", Description: "Limit transfer speed to RATE"},
		{Text: "--list-only", Description: "List only mode"},
		{Text: "--local-port", Description: "Force use of RANGE for local port numbers"},
		{Text: "--location", Description: "Follow redirects"},
		{Text: "--location-trusted", Description: "Like --location, and send auth to other hosts"},
		{Text: "--login-options", Description: "Server login options"},
		{Text: "--mail-auth", Description: "Originator address of the original email"},
		{Text: "--mail-from", Description: "Mail from this address"},
		{Text: "--mail-rcpt", Description: "Mail to this address"},
		{Text: "--manual", Description: "Display the full manual"},
		{Text: "--max-filesize", Description: "Maximum file size to download"},
		{Text: "--max-redirs", Description: "Maximum number of redirects allowed"},
		{Text: "--max-time", Description: "Maximum time allowed for the transfer"},
		{Text: "--metalink", Description: "Process given URLs as metalink XML file"},
		{Text: "--negotiate", Description: "Use HTTP Negotiate (SPNEGO) authentication"},
		{Text: "--netrc", Description: "Must read .netrc for user name and password"},
		{Text: "--netrc-file", Description: "Specify FILE for netrc"},
		{Text: "--netrc-optional", Description: "Use either .netrc or URL"},
		{Text: "--next", Description: "Make next URL use its separate set of options"},
		{Text: "--no-alpn", Description: "Disable the ALPN TLS extension"},
		{Text: "--no-buffer", Description: "Disable buffering of the output stream"},
		{Text: "--no-keepalive", Description: "Disable TCP keepalive on the connection"},
		{Text: "--no-npn", Description: "Disable the NPN TLS extension"},
		{Text: "--no-sessionid", Description: "Disable SSL session-ID reusing"},
		{Text: "--noproxy", Description: "List of hosts which do not use proxy"},
		{Text: "--ntlm", Description: "Use HTTP NTLM authentication"},
		{Text: "--ntlm-wb", Description: "Use HTTP NTLM authentication with winbind"},
		{Text: "--oauth2-bearer", Description: "OAuth 2 Bearer Token"},
		{Text: "--output", Description: "Write to file instead of stdout"},
		{Text: "--pass", Description: "Pass phrase for the private key"},
		{Text: "--path-as-is", Description: "Do not squash .. sequences in URL path"},
		{Text: "--pinnedpubkey", Description: "FILE/HASHES Public key to verify peer against"},
		{Text: "--post301", Description: "Do not switch to GET after following a 301"},
		{Text: "--post302", Description: "Do not switch to GET after following a 302"},
		{Text: "--post303", Description: "Do not switch to GET after following a 303"},
		{Text: "--preproxy", Description: "[protocol://]host[:port] Use this proxy first"},
		{Text: "--progress-bar", Description: "Display transfer progress as a bar"},
		{Text: "--proto", Description: "Enable/disable PROTOCOLS"},
		{Text: "--proto-default", Description: "Use PROTOCOL for any URL missing a scheme"},
		{Text: "--proto-redir", Description: "Enable/disable PROTOCOLS on redirect"},
		{Text: "--proxy", Description: "[protocol://]host[:port] Use this proxy"},
		{Text: "--proxy-anyauth", Description: "Pick any proxy authentication method"},
		{Text: "--proxy-basic", Description: "Use Basic authentication on the proxy"},
		{Text: "--proxy-cacert", Description: "CA certificate to verify peer against for proxy"},
		{Text: "--proxy-capath", Description: "CA directory to verify peer against for proxy"},
		{Text: "--proxy-cert", Description: "Set client certificate for proxy"},
		{Text: "--proxy-cert-type", Description: "Client certificate type for HTTPS proxy"},
		{Text: "--proxy-ciphers", Description: "SSL ciphers to use for proxy"},
		{Text: "--proxy-crlfile", Description: "Set a CRL list for proxy"},
		{Text: "--proxy-digest", Description: "Use Digest authentication on the proxy"},
		{Text: "--proxy-header", Description: "Pass custom header(s) to proxy"},
		{Text: "--proxy-insecure", Description: "Do HTTPS proxy connections without verifying the proxy"},
		{Text: "--proxy-key", Description: "Private key for HTTPS proxy"},
		{Text: "--proxy-key-type", Description: "Private key file type for prox@"},
		{Text: "--proxy-negotiate", Description: "Use HTTP Negotiate (SPNEGO) authentication on the proxy"},
		{Text: "--proxy-ntlm", Description: "Use NTLM authentication on the proxy"},
		{Text: "--proxy-pass", Description: "Pass phrase for the private key for HTTPS proxy"},
		{Text: "--proxy-pinnedpubkey", Description: "FILE/HASHES public key to verify proxy with"},
		{Text: "--proxy-service-name", Description: "SPNEGO proxy service name"},
		{Text: "--proxy-ssl-allow-beast", Description: "Allow security flaw for interop for HTTPS proxy"},
		{Text: "--proxy-tls13-ciphers", Description: "TLS 1.3 proxy cipher suites"},
		{Text: "--proxy-tlsauthtype", Description: "TLS authentication type for HTTPS proxy"},
		{Text: "--proxy-tlspassword", Description: "TLS password for HTTPS proxy"},
		{Text: "--proxy-tlsuser", Description: "TLS username for HTTPS proxy"},
		{Text: "--proxy-tlsv1", Description: "Use TLSv1 for HTTPS proxy"},
		{Text: "--proxy-user", Description: "Proxy user and password"},
		{Text: "--proxy1.0", Description: "Use HTTP/1.0 proxy on given port"},
		{Text: "--proxytunnel", Description: "Operate through an HTTP proxy tunnel (using CONNECT)"},
		{Text: "--pubkey", Description: "SSH Public key file name"},
		{Text: "--quote", Description: "Send command(s) to server before transfer"},
		{Text: "--random-file", Description: "File for reading random data from"},
		{Text: "--range", Description: "Retrieve only the bytes within RANGE"},
		{Text: "--raw", Description: "Do HTTP 'raw'; no transfer decoding"},
		{Text: "--referer", Description: "Referrer URL"},
		{Text: "--remote-header-name", Description: "Use the header-provided filename"},
		{Text: "--remote-name", Description: "Write output to a file named as the remote file"},
		{Text: "--remote-name-all", Description: "Use the remote file name for all URLs"},
		{Text: "--remote-time", Description: "Set the remote file's time on the local output"},
		{Text: "--request", Description: "Specify request command to use"},
		{Text: "--request-target", Description: "Specify the target for this request"},
		{Text: "--resolve", Description: "Resolve the host+port to this address"},
		{Text: "--retry", Description: "Retry request if transient problems occur"},
		{Text: "--retry-connrefused", Description: "Retry on connection refused (use with --retry)"},
		{Text: "--retry-delay", Description: "Wait time between retries"},
		{Text: "--retry-max-time", Description: "Retry only within this period"},
		{Text: "--sasl-ir", Description: "Enable initial response in SASL authentication"},
		{Text: "--service-name", Description: "SPNEGO service name"},
		{Text: "--show-error", Description: "Show error even when -s is used"},
		{Text: "--silent", Description: "Silent mode"},
		{Text: "--socks4", Description: "SOCKS4 proxy on given host + port"},
		{Text: "--socks4a", Description: "SOCKS4a proxy on given host + port"},
		{Text: "--socks5", Description: "SOCKS5 proxy on given host + port"},
		{Text: "--socks5-basic", Description: "Enable username/password auth for SOCKS5 proxies"},
		{Text: "--socks5-gssapi", Description: "Enable GSS-API auth for SOCKS5 proxies"},
		{Text: "--socks5-gssapi-nec", Description: "Compatibility with NEC SOCKS5 server"},
		{Text: "--socks5-gssapi-service", Description: "SOCKS5 proxy service name for GSS-API"},
		{Text: "--socks5-hostname", Description: "SOCKS5 proxy, pass host name to proxy"},
		{Text: "--speed-limit", Description: "Stop transfers slower than this"},
		{Text: "--speed-time", Description: "Trigger 'speed-limit' abort after this time"},
		{Text: "--ssl", Description: "Try SSL/TLS"},
		{Text: "--ssl-allow-beast", Description: "Allow security flaw to improve interop"},
		{Text: "--ssl-no-revoke", Description: "Disable cert revocation checks (Schannel)"},
		{Text: "--ssl-reqd", Description: "Require SSL/TLS"},
		{Text: "--sslv2", Description: "Use SSLv2"},
		{Text: "--sslv3", Description: "Use SSLv3"},
		{Text: "--stderr", Description: "Where to redirect stderr"},
		{Text: "--styled-output", Description: "Enable styled output for HTTP headers"},
		{Text: "--suppress-connect-headers", Description: "Suppress proxy CONNECT response headers"},
		{Text: "--tcp-fastopen", Description: "Use TCP Fast Open"},
		{Text: "--tcp-nodelay", Description: "Use the TCP_NODELAY option"},
		{Text: "--telnet-option", Description: "Set telnet option"},
		{Text: "--tftp-blksize", Description: "Set TFTP BLKSIZE option"},
		{Text: "--tftp-no-options", Description: "Do not send any TFTP options"},
		{Text: "--time-cond", Description: "Transfer based on a time condition"},
		{Text: "--tls-max", Description: "Set maximum allowed TLS version"},
		{Text: "--tls13-ciphers", Description: "TLS 1.3 cipher suites to use"},
		{Text: "--tlsauthtype", Description: "TLS authentication type"},
		{Text: "--tlspassword", Description: "TLS password"},
		{Text: "--tlsuser", Description: "TLS user name"},
		{Text: "--tlsv1", Description: "Use TLSv1.0 or greater"},
		{Text: "--tlsv1.0", Description: "Use TLSv1.0 or greater"},
		{Text: "--tlsv1.1", Description: "Use TLSv1.1 or greater"},
		{Text: "--tlsv1.2", Description: "Use TLSv1.2 or greater"},
		{Text: "--tlsv1.3", Description: "Use TLSv1.3 or greater"},
		{Text: "--tr-encoding", Description: "Request compressed transfer encoding"},
		{Text: "--trace", Description: "Write a debug trace to FILE"},
		{Text: "--trace-ascii", Description: "Like --trace, but without hex output"},
		{Text: "--trace-time", Description: "Add time stamps to trace/verbose output"},
		{Text: "--unix-socket", Description: "Connect through this Unix domain socket"},
		{Text: "--upload-file", Description: "Transfer local FILE to destination"},
		{Text: "--url", Description: "URL to work with"},
		{Text: "--use-ascii", Description: "Use ASCII/text transfer"},
		{Text: "--user", Description: "Server user and password"},
		{Text: "--user-agent", Description: "Send User-Agent <name> to server"},
		{Text: "--verbose", Description: "Make the operation more talkative"},
		{Text: "--version", Description: "Show version number and quit"},
		{Text: "--write-out", Description: "Use output FORMAT after completion"},
		{Text: "--xattr", Description: "Store metadata in extended file attributes"},
	}

	return prompt.FilterFuzzy(s, d.GetWordBeforeCursor(), true)
}

func shortOptionCompleter(d prompt.Document) []prompt.Suggest {
	s := []prompt.Suggest{
		{Text: "", Description: ""},
		{Text: "-a", Description: "Append to target file when uploading"},
		{Text: "-E", Description: "Client certificate file and password"},
		{Text: "-K", Description: "Read config from a file"},
		{Text: "-C", Description: "Resumed transfer offset"},
		{Text: "-b", Description: "Send cookies from string/file"},
		{Text: "-c", Description: "Write cookies to <filename> after operation"},
		{Text: "-d", Description: "HTTP POST data"},
		{Text: "-q", Description: "Disable .curlrc"},
		{Text: "-D", Description: "Write the received headers to <filename>"},
		{Text: "-f", Description: "Fail silently (no output at all) on HTTP errors"},
		{Text: "-F", Description: "Specify multipart MIME data"},
		{Text: "-P", Description: "Use PORT instead of PAS"},
		{Text: "-G", Description: "Put the post data in the URL and use GET"},
		{Text: "-g", Description: "Disable URL sequences and ranges using {} and []"},
		{Text: "-I", Description: "Show document info only"},
		{Text: "-H", Description: "Pass custom header(s) to server"},
		{Text: "-h", Description: "This help text"},
		{Text: "-0", Description: "Use HTTP 1.0"},
		{Text: "-i", Description: "Include protocol response headers in the output"},
		{Text: "-k", Description: "Allow insecure server connections when using SSL"},
		{Text: "-4", Description: "Resolve names to IPv4 addresses"},
		{Text: "-6", Description: "Resolve names to IPv6 addresses"},
		{Text: "-l", Description: "List only mode"},
		{Text: "-L", Description: "Follow redirects"},
		{Text: "-M", Description: "Display the full manual"},
		{Text: "-m", Description: "Maximum time allowed for the transfer"},
		{Text: "-n", Description: "Must read .netrc for user name and password"},
		{Text: "-:", Description: "Make next URL use its separate set of options"},
		{Text: "-N", Description: "Disable buffering of the output stream"},
		{Text: "-o", Description: "Write to file instead of stdout"},
		{Text: "-#", Description: "Display transfer progress as a bar"},
		{Text: "-x", Description: "Use this proxy"},
		{Text: "-U", Description: "Proxy user and password"},
		{Text: "-p", Description: "Operate through an HTTP proxy tunnel (using CONNECT)"},
		{Text: "-Q", Description: "Send command(s) to server before transfer"},
		{Text: "-r", Description: "Retrieve only the bytes within RANGE"},
		{Text: "-e", Description: "Referrer URL"},
		{Text: "-J", Description: "Use the header-provided filename"},
		{Text: "-O", Description: "Write output to a file named as the remote file"},
		{Text: "-R", Description: "Set the remote file's time on the local output"},
		{Text: "-X", Description: "Specify request command to use"},
		{Text: "-S", Description: "Show error even when -s is used"},
		{Text: "-s", Description: "Silent mode"},
		{Text: "-Y", Description: "Stop transfers slower than this"},
		{Text: "-y", Description: "Trigger 'speed-limit' abort after this time"},
		{Text: "-2", Description: "Use SSLv2"},
		{Text: "-3", Description: "Use SSLv3"},
		{Text: "-t", Description: "Set telnet option"},
		{Text: "-z", Description: "Transfer based on a time condition"},
		{Text: "-1", Description: "Use TLSv1.0 or greater"},
		{Text: "-T", Description: "Transfer local FILE to destination"},
		{Text: "-B", Description: "Use ASCII/text transfer"},
		{Text: "-u", Description: "Server user and password"},
		{Text: "-A", Description: "Send User-Agent <name> to server"},
		{Text: "-v", Description: "Make the operation more talkative"},
		{Text: "-V", Description: "Show version number and quit"},
		{Text: "-w", Description: "Use output FORMAT after completion"},
	}

	return prompt.FilterFuzzy(s, d.GetWordBeforeCursor(), true)
}
